var Xport = function()
{
	var xport = {};
	var previewTitle;
	var previewList;
	
	xport.initPage = function()
	{
		previewTitle = Doc.element('previewTitle');
		previewList = Doc.element('previewList');
		
		Buttons.addClickHandler('goexport', xport.goExport);
		Buttons.addClickHandler('gopreview', xport.goPreview);

		Doc.show('step-1');
		Doc.show('gopreview');
		Doc.show('goexport');
	}
	
	xport.goPreview = function()
	{
		xport.doExport(true);
	}
	
	xport.goExport = function()
	{
		xport.doExport(false);
	}
	
	xport.doExport = function(preview)
	{
		var frm = document.forms['reggie'];
		var url = '../Export.servlet?ID='+App.getSessionId();
		url += '&cmd=ExportMissingSampleDataSampleList';
		url += '&stype='+frm.sampletype.value;
		url += '&exportSubtype=1';
		url += '&exportPatientId=1';
		
		if (preview) 
		{
			Doc.hide('previewWrapper');
			url += '&preview=1';
			
			Wizard.showLoadingAnimation('Working...');
			Doc.hide('navigation');
			Wizard.asyncJsonRequest(url, xport.onPreviewLoaded);

		}
		else
		{
			window.location = url;		
		}
	}

	xport.onPreviewLoaded = function(response)
	{
		Doc.show('navigation');
		var frm = document.forms['reggie'];
		
		var allLines = response.split('\n');
		var numCases = allLines.length - 2; // First line is a header line
		var numSpecimen = 0;
		var numNoSpecimen = 0;
		
		var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
		// Check second column for the 'Subtype' value
		var numNoConsent = 0;
		var numMissingConsent = 0;
		for (var i = 1 ; i <= numCases; i++)
		{
			var line = allLines[i];
			var cols = line.split(/\t/);
			var sampleSubtype = cols[1];
			if (sampleSubtype == 'Specimen')
			{
				numSpecimen++;
			}
			else if (sampleSubtype == 'NoSpecimen')
			{
				numNoSpecimen++;
			}
			var rowClass = '';
			html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
		}

		var sampleTypes = frm.sampletype[frm.sampletype.selectedIndex].text;
		previewTitle.innerHTML = 'Sample type(s) - ' + sampleTypes + ' (' + numCases + ')';
		if (sampleTypes == 'Specimen/No specimen')
		{
			// Report the number of each subtype for 'Specimen/No specimen'
			previewTitle.innerHTML = 'Sample type(s) - Specimen (' + numSpecimen + ')/No specimen (' + numNoSpecimen + ') Total (' + numCases + ')';
		}
		previewList.innerHTML = '<table>'+html+'</table>';
		Doc.show('previewWrapper');
	}

	return xport;
}();

Doc.onLoad(Xport.initPage);

